﻿
; Créé par Monsieur Dieppedalle David le 22/03/2017.
; Amélioré par Micoute (Structure + Tableau) le 24.03.2027.
; Amélioration et Optimisation par Monsieur Dieppedalle David le 24/03/2017.
; Ajouté par la suite moult fonctions et améliorations.
; Faute d'orthographe corrigée par Micoute.

;{ Structure
Structure Caracteristiques
  BoutonImageID.i
  Texte.s
  PositionTexteBouton.i
  XTexte.i
  YTexte.i
  CouleurTexte.i
  AngleTexte.i
  StyleTexte.i
  PoliceTexte.s
  TailleTexte.i
  FontTexte.i
  OffsetXTexteBouton.i
  OffsetYTexteBouton.i
  CouleurBouton.i
  StyleBouton.i
  Curseur.i
  ImageBouton.i
  TransparenceImageBouton.i
  PositionImageBouton.i
  XImageBouton.i
  YImageBouton.i
  OffsetXImageBouton.i
  OffsetYImageBouton.i
  CouleurGradientTexte1.i
  CouleurGradientTexte2.i
  CouleurGradientTexte3.i
  CouleurGradientTexte4.i
  CouleurGradientTexte5.i
  CouleurGradientFond1.i
  CouleurGradientFond2.i
  CouleurGradientFond3.i
  CouleurGradientFond4.i
  CouleurGradientFond5.i
  GradientModeTexte.i
  GradientModeFond.i
  Interrupteur.b
EndStructure  
;}

;{ Variables Globales
Global NewMap ArrayButtonColor.Caracteristiques()
;}

;{ Constantes personnalisées:

; Valeurs possibles pour le Curseur:
#BC_Cursor_ARROW = 32512 ; la flèche (le curseur normal)
#BC_Cursor_IBEAM = 32513 ; curseur sélection de texte
#BC_Cursor_UPARROW = 32516 ; flèche qui pointe vers le haut
#BC_Cursor_APPSTARTING = 32650 ; curseur attente (flèche + sablier)
#BC_Cursor_WAIT = 32514        ; curseur occupé (sablier)
#BC_Cursor_CROSS = 32515       ; curseur précision de la sélection (croix)
#BC_Cursor_SIZENWSE = 32642    ; curseur de dimensionnement, pointe le NordOuest et le SudEst
#BC_Cursor_SIZENESW = 32643    ; curseur de dimensionnement, pointe le NE et le SO
#BC_Cursor_SIZEWE = 32644      ; curseur de dimensionnement, pointe le E et le O
#BC_Cursor_SIZENS = 32645      ; curseur de dimensionnement, pointe le N et le S
#BC_Cursor_SIZEALL = 32646     ; curseur de déplacement, pointe le N, S, E et O
#BC_Cursor_HELP = 32651        ; curseur aide
#BC_Cursor_HAND = 32649        ; curseur main
#BC_Cursor_NO = 32648          ; curseur "interdit" (panneau d'interdiction)

; Valeurs possibles pour les Fontes:
#BC_Font_Bold = #PB_Font_Bold
#BC_Font_Italic = #PB_Font_Italic
#BC_Font_Underline = #PB_Font_Underline
#BC_Font_StrikeOut = #PB_Font_StrikeOut

Enumeration 1
  
  #BC_TextColor
  #BC_GradiantTextMode
  #BC_GradiantTextColor1
  #BC_GradiantTextColor2
  #BC_GradiantTextColor3
  #BC_GradiantTextColor4
  #BC_GradiantTextColor5
  #BC_TextPosition
  #BC_TextX
  #BC_TextY
  #BC_TextOffSetX
  #BC_TextOffSetY
  #BC_BackColor
  #BC_GradiantFondMode
  #BC_GradiantBackColor1
  #BC_GradiantBackColor2
  #BC_GradiantBackColor3
  #BC_GradiantBackColor4
  #BC_GradiantBackColor5
  #BC_AngleText
  #BC_Cursor
  #BC_Image
  #BC_ImageTransparence
  #BC_ImageX
  #BC_ImageY
  #BC_ImageOffSetX
  #BC_ImageOffSetY
  #BC_ImagePosition
  #BC_Toogle
  #BC_Style
  #BC_Style_Default
  #BC_Style_Flat
  #BC_Style_NoBorder
  #BC_Style_3D
  
EndEnumeration

;}

;{ Procédures

; Procédure pour changer le curseur de la souris au dessus d'un gadget.

; Auteur : Le Soldat Inconnu
; Version de PB : 4.50
Procedure SetGadgetCursor_SubClassProc(hwnd, msg, wparam, lparam)
  Protected oldproc, Cursor
  oldproc = GetProp_(hwnd, "oldproc")
  
  Select msg
    Case #WM_NCDESTROY
      RemoveProp_(hwnd, "oldproc")
      RemoveProp_(hwnd, "cursor")
      
    Case #WM_SETCURSOR
      Cursor = GetProp_(hwnd, "cursor")
      SetCursor_(Cursor)
      ProcedureReturn 0
      
  EndSelect   
  ProcedureReturn CallWindowProc_(oldproc, hwnd, msg, wparam, lparam)
EndProcedure

 ; Change le curseur de la souris au dessus d'un Gadget.
Procedure SetGadgetCursor(Gadget, Cursor)
  If IsGadget(Gadget)
    If GetProp_(GadgetID(Gadget), "cursor")
      RemoveProp_(GadgetID(Gadget), "cursor")
    EndIf
    SetProp_(GadgetID(Gadget), "cursor", Cursor)
    If GetProp_(GadgetID(Gadget), "oldproc") = 0
      SetProp_(GadgetID(Gadget), "oldproc", SetWindowLongPtr_(GadgetID(Gadget), #GWL_WNDPROC, @SetGadgetCursor_SubClassProc()))
    EndIf
    SendMessage_(GadgetID(Gadget), #WM_SETCURSOR , 0, 0)
  EndIf
EndProcedure

; Créer un nouveau Bouton Coloré.
Procedure.b CreateButtonColor(Gadget.i, X.i, Y.i, Largeur.i, Hauteur.i, Texte.s, CouleurTexte.i = 0, CouleurBouton.i = 0, Interrupteur.b = #False, Curseur.i = #BC_Cursor_ARROW)
  
  If Largeur.i > 9 And Hauteur.i > 9
    
    With ArrayButtonColor(Str(Gadget.i))
      
      If CouleurTexte.i = 0
        CouleurTexte.i = RGBA(0, 0, 0, 255)
      EndIf
      
      \Texte = Texte.s
      \CouleurTexte = CouleurTexte.i
      \CouleurBouton = CouleurBouton.i
      \Interrupteur = Interrupteur.b
      \Curseur = Curseur.i
      
      If IsImage(\BoutonImageID)
        FreeImage(\BoutonImageID)
      EndIf
      
      ButtonImage.i = CreateImage(#PB_Any, Largeur.i - 7, Hauteur.i - 7, 32, #PB_Image_Transparent)
      
      If IsImage(ButtonImage.i)
        
        \BoutonImageID = ButtonImage.i
        
        If Not IsFont(\FontTexte)
          
          ButtonFont.i = LoadFont(#PB_Any, "", 8, #PB_Font_HighQuality)
          
          If IsFont(ButtonFont.i)
            \PoliceTexte = ""
            \TailleTexte = 8
            \StyleTexte = #PB_Font_HighQuality
            \FontTexte = ButtonFont.i
          EndIf
          
        EndIf
        
        If StartDrawing(ImageOutput(ButtonImage.i))
          
          DrawingMode(#PB_2DDrawing_AlphaBlend)
          Box(0, 0, ImageWidth(ButtonImage.i), ImageHeight(ButtonImage.i), CouleurBouton.i)
          
          If \GradientModeFond = 1
            
            DrawingMode(#PB_2DDrawing_Gradient)
            
            ; Dégradé en Horizontal.
            LinearGradient(ImageWidth(ButtonImage.i), 0, 0, 0)
            
          ElseIf \GradientModeFond = 2
            
            DrawingMode(#PB_2DDrawing_Gradient)
            
            ; Dégradé en Vertical.
            LinearGradient(0, ImageHeight(ButtonImage.i), 0, 0)
            
          EndIf
          
          If \GradientModeFond = 1 Or \GradientModeFond = 2
            
            If \CouleurGradientFond1 <> -1 And \CouleurGradientFond2 <> -1 And \CouleurGradientFond3 <> -1 And \CouleurGradientFond4 <> -1 And \CouleurGradientFond5 <> -1
              GradientColor(0.00, \CouleurGradientFond1)
              GradientColor(0.25, \CouleurGradientFond2)   
              GradientColor(0.50, \CouleurGradientFond3)
              GradientColor(0.75, \CouleurGradientFond4)
              GradientColor(1.00, \CouleurGradientFond5)
              
            ElseIf \CouleurGradientFond1 <> -1 And \CouleurGradientFond2 <> -1 And \CouleurGradientFond3 <> -1 And \CouleurGradientFond4 <> -1
              GradientColor(0.00, \CouleurGradientFond1)
              GradientColor(0.33, \CouleurGradientFond2)   
              GradientColor(0.66, \CouleurGradientFond3)
              GradientColor(1.00, \CouleurGradientFond4)
              
            ElseIf \CouleurGradientFond1 <> -1 And \CouleurGradientFond2 <> -1 And \CouleurGradientFond3 <> -1
              GradientColor(0.00, \CouleurGradientFond1)
              GradientColor(0.50, \CouleurGradientFond2)   
              GradientColor(1.00, \CouleurGradientFond3)
              
            ElseIf \CouleurGradientFond1 <> -1 And \CouleurGradientFond2 <> -1
              GradientColor(0.00, \CouleurGradientFond1)
              GradientColor(1.00, \CouleurGradientFond2)   
              
            Else
              DrawingMode(#PB_2DDrawing_AlphaBlend)
              
            EndIf
            
          EndIf
          
          Box(0, 0, ImageWidth(ButtonImage.i), ImageHeight(ButtonImage.i), CouleurBouton.i)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
          
          If IsFont(\FontTexte)
            DrawingFont(FontID(\FontTexte))
          EndIf
          
          AngleTexte.i = (\AngleTexte - \AngleTexte - \AngleTexte)
          
          If AngleTexte.i = 0
            
            Select \PositionTexteBouton
                
              Case 0 ; Centre
                XTexte.i = (ImageWidth(ButtonImage.i) - TextWidth(Texte.s)) / 2 + \OffsetXTexteBouton
                YTexte.i = (ImageHeight(ButtonImage.i) - TextHeight(Texte.s)) / 2 + \OffsetYTexteBouton
                
              Case 1 ; Haut Gauche
                XTexte.i = 1 + \OffsetXTexteBouton
                YTexte.i = \OffsetYTexteBouton - 2
                
              Case 2 ; Haut centre
                XTexte.i = 1 + (ImageWidth(ButtonImage.i) - TextWidth(Texte.s)) / 2 + \OffsetXTexteBouton
                YTexte.i = \OffsetYTexteBouton - 2
                
              Case 3 ; Haut droite
                XTexte.i = ImageWidth(ButtonImage.i) - TextWidth(Texte.s) + \OffsetXTexteBouton - 1
                YTexte.i = \OffsetYTexteBouton - 2
                
              Case 4 ; Gauche centre
                XTexte.i = 1 + \OffsetXTexteBouton
                YTexte.i = (ImageHeight(ButtonImage.i) - TextHeight(Texte.s)) / 2 + \OffsetYTexteBouton
                
              Case 5 ; Droite centre
                XTexte.i = (ImageWidth(ButtonImage.i) - TextWidth(Texte.s)) + \OffsetXTexteBouton - 1
                YTexte.i = (ImageHeight(ButtonImage.i) - TextHeight(Texte.s)) / 2 + \OffsetYTexteBouton
                
              Case 6 ; Bas gauche
                XTexte.i = 1 + \OffsetXTexteBouton
                YTexte.i = (ImageHeight(ButtonImage.i) - TextHeight(Texte.s)) + \OffsetYTexteBouton
                
              Case 7 ; Bas centre
                XTexte.i = 1 + (ImageWidth(ButtonImage.i) - TextWidth(Texte.s)) / 2 + \OffsetXTexteBouton
                YTexte.i = (ImageHeight(ButtonImage.i) - TextHeight(Texte.s)) + \OffsetYTexteBouton
                
              Case 8 ; Bas droite
                XTexte.i = ImageWidth(ButtonImage.i) - TextWidth(Texte.s) + \OffsetXTexteBouton - 1
                YTexte.i = (ImageHeight(ButtonImage.i) - TextHeight(Texte.s)) + \OffsetYTexteBouton
                
              Default ; Centre
                XTexte.i = (ImageWidth(ButtonImage.i) - TextWidth(Texte.s)) / 2 + \OffsetXTexteBouton
                YTexte.i = (ImageHeight(ButtonImage.i) - TextHeight(Texte.s)) / 2 + \OffsetYTexteBouton
                
            EndSelect
            
          Else
            
            XTexte.i = (ImageWidth(ButtonImage.i) - TextWidth(\Texte) * Cos(Radian(AngleTexte.i)) - TextHeight(\Texte) * Sin(Radian(AngleTexte.i))) / 2
            YTexte.i = (ImageHeight(ButtonImage.i) + TextWidth(\Texte) * Sin(Radian(AngleTexte.i)) - TextHeight(\Texte) * Cos(Radian(AngleTexte.i))) / 2
            
            XTexte.i + \OffsetXTexteBouton
            YTexte.i + \OffsetYTexteBouton
            
          EndIf
          
          \XTexte = XTexte.i
          \YTexte = YTexte.i
          
          If IsImage(\ImageBouton)
            
            Select \PositionImageBouton
                
              Case 0 ; Haut Gauche
                XImage.i = 1
                YImage.i = 1
                
              Case 1 ; Haut centre
                XImage.i = (ImageWidth(ButtonImage.i) - ImageWidth(\ImageBouton)) / 2 + \OffSetXImageBouton
                YImage.i = 1 + \OffSetYImageBouton
                
              Case 2 ; Haut droite
                XImage.i = (ImageWidth(ButtonImage.i) - ImageWidth(\ImageBouton)) - 1 + \OffSetXImageBouton
                YImage.i = 1 + \OffSetYImageBouton
                
              Case 3 ; Gauche centre
                XImage.i = 1 + \OffSetXImageBouton
                YImage.i = (ImageHeight(ButtonImage.i) - ImageHeight(\ImageBouton)) / 2 + \OffSetYImageBouton
                
              Case 4 ; Centre
                XImage.i = (ImageWidth(ButtonImage.i) - ImageWidth(\ImageBouton)) / 2 + \OffSetXImageBouton
                YImage.i = (ImageHeight(ButtonImage.i) - ImageHeight(\ImageBouton)) / 2 + \OffSetYImageBouton
                
              Case 5 ; Droite centre
                XImage.i = (ImageWidth(ButtonImage.i) - ImageWidth(\ImageBouton)) - 1 + \OffSetXImageBouton
                YImage.i = (ImageHeight(ButtonImage.i) - ImageHeight(\ImageBouton)) / 2 + \OffSetYImageBouton
                
              Case 6 ; Bas gauche
                XImage.i = 1 + \OffSetXImageBouton
                YImage.i = ImageHeight(ButtonImage.i) - ImageHeight(\ImageBouton) - 1 + \OffSetYImageBouton
                
              Case 7 ; Bas centre
                XImage.i = (ImageWidth(ButtonImage.i) - ImageWidth(\ImageBouton)) / 2 + \OffSetXImageBouton
                YImage.i = ImageHeight(ButtonImage.i) - ImageHeight(\ImageBouton) - 1 + \OffSetYImageBouton
                
              Case 8 ; Bas droite
                XImage.i = ImageWidth(ButtonImage.i) - ImageWidth(\ImageBouton) - 1 + \OffSetXImageBouton
                YImage.i = ImageHeight(ButtonImage.i) - ImageHeight(\ImageBouton) - 1 + \OffSetYImageBouton
                
              Default ; Haut Gauche
                XImage.i = 1 + \OffSetXImageBouton
                YImage.i = 1 + \OffSetYImageBouton
                
            EndSelect
            
            \XImageBouton = XImage.i
            \YImageBouton = YImage.i
            
            DrawAlphaImage(ImageID(\ImageBouton), XImage.i, YImage.i, \TransparenceImageBouton)
            
          EndIf
          
          ResetGradientColors()
          
          If \GradientModeTexte = 1 Or \GradientModeTexte = 2
            
            DrawingMode(#PB_2DDrawing_AlphaBlend | #PB_2DDrawing_Gradient)
            
            If \GradientModeTexte = 1
              
              ; Dégradé en Horizontal.
              LinearGradient(XTexte.i, YTexte.i, TextWidth(Texte.s), YTexte.i)
              
            ElseIf \GradientModeTexte = 2
              
              ; Dégradé en Vertical.
              LinearGradient(XTexte.i, YTexte.i, XTexte.i, YTexte.i + TextHeight(Texte.s))
              
            EndIf
            
            If \CouleurGradientTexte1 <> -1 And \CouleurGradientTexte2 <> -1 And \CouleurGradientTexte3 <> -1 And \CouleurGradientTexte4 <> -1 And \CouleurGradientTexte5 <> -1
              GradientColor(0.00, \CouleurGradientTexte1)
              GradientColor(0.25, \CouleurGradientTexte2)   
              GradientColor(0.50, \CouleurGradientTexte3)
              GradientColor(0.75, \CouleurGradientTexte4)
              GradientColor(1.00, \CouleurGradientTexte5)
              
            ElseIf \CouleurGradientTexte1 <> -1 And \CouleurGradientTexte2 <> -1 And \CouleurGradientTexte3 <> -1 And \CouleurGradientTexte4 <> -1
              GradientColor(0.00, \CouleurGradientTexte1)
              GradientColor(0.33, \CouleurGradientTexte2)   
              GradientColor(0.66, \CouleurGradientTexte3)
              GradientColor(1.00, \CouleurGradientTexte4)
              
            ElseIf \CouleurGradientTexte1 <> -1 And \CouleurGradientTexte2 <> -1 And \CouleurGradientTexte3 <> -1
              GradientColor(0.00, \CouleurGradientTexte1)
              GradientColor(0.50, \CouleurGradientTexte2)   
              GradientColor(1.00, \CouleurGradientTexte3)
              
            ElseIf \CouleurGradientTexte1 <> -1 And \CouleurGradientTexte2 <> -1
              GradientColor(0.00, \CouleurGradientTexte1)
              GradientColor(1.00, \CouleurGradientTexte2)
              
            Else
              DrawingMode(#PB_2DDrawing_AlphaBlend)
              
            EndIf
            
          EndIf
          
          If AngleTexte.i = 0
            DrawText(XTexte.i, YTexte.i, Texte.s, CouleurTexte.i, 0)
            
          Else
            DrawRotatedText(XTexte.i, YTexte.i, Texte.s, AngleTexte.i, CouleurTexte.i)
            
          EndIf
          
          StopDrawing()
          
        Else
          ProcedureReturn 0
          
        EndIf
        
        If Interrupteur.b = #True
          ButtonImageGadget(Gadget.i, X.i, Y.i, Largeur.i, Hauteur.i, ImageID(ButtonImage.i), #PB_Button_Toggle)
        Else
          ButtonImageGadget(Gadget.i, X.i, Y.i, Largeur.i, Hauteur.i, ImageID(ButtonImage.i))
        EndIf
        
      Else
        ProcedureReturn 0
        
      EndIf
      
      Select \StyleBouton
          
      Case #BC_Style_Flat
        SetWindowLong_(GadgetID(Gadget.i), #GWL_STYLE, #BS_FLAT | GetWindowLong_(GadgetID(Gadget.i), #GWL_STYLE))
        SetWindowTheme_(GadgetID(Gadget), @" ", @" ")
        
      Case #BC_Style_NoBorder
        SetWindowLong_(GadgetID(Gadget.i), #GWL_STYLE, #BS_USERBUTTON | GetWindowLong_(GadgetID(Gadget.i), #GWL_STYLE))
        SetWindowTheme_(GadgetID(Gadget.i), @" ", @" ")
        
      Case #BC_Style_3D
        SetWindowLong_(GadgetID(Gadget.i), #GWL_STYLE, 0 | GetWindowLong_(GadgetID(Gadget.i), #GWL_STYLE))
        SetWindowTheme_(GadgetID(Gadget.i), @" ", @" ")
        
      EndSelect
      
      Select Curseur.i
          
        Case 0, #BC_Cursor_APPSTARTING, #BC_Cursor_ARROW, #BC_Cursor_CROSS, #BC_Cursor_HAND, #BC_Cursor_HELP, #BC_Cursor_IBEAM, #BC_Cursor_NO, #BC_Cursor_SIZEALL, #BC_Cursor_SIZENESW, #BC_Cursor_SIZEWE, #BC_Cursor_SIZENS, #BC_Cursor_SIZENWSE, #BC_Cursor_UPARROW, #BC_Cursor_WAIT
          
        Default
          Curseur.i = #BC_Cursor_ARROW
          
      EndSelect
      
      SetGadgetCursor(Gadget.i, LoadCursor_(0, Curseur.i)) ; Applique le curseur au gadget
      ProcedureReturn 1
      
    EndWith
    
  Else
    ProcedureReturn 0
    
  EndIf
  
EndProcedure

; Change le texte du bouton.
Procedure.b SetButtonColorText(Gadget.i, Texte.s)
  
  If IsGadget(Gadget.i)
    With ArrayButtonColor(Str(Gadget.i))
      \Texte = Texte.s
      If CreateButtonColor(Gadget.i, GadgetX(Gadget.i), GadgetY(Gadget.i), GadgetWidth(Gadget.i), GadgetHeight(Gadget.i), Texte.s, \CouleurTexte, \CouleurBouton, \Interrupteur, \Curseur)
        ProcedureReturn 1
      Else
        ProcedureReturn 0
      EndIf
    EndWith
  Else
    ProcedureReturn 0
  EndIf
  
EndProcedure

; Change la police du bouton.
Procedure.b SetGadgetColorFont(Gadget.i, PoliceTexte.s, TailleTexte.i = 10, StyleTexte.i = 0)
  
  ; StyleTexte: #BC_Font_Bold | #BC_Font_Italic | #BC_Font_Underline | #BC_Font_StrikeOut
  
  If IsGadget(Gadget.i)
    
    With ArrayButtonColor(Str(Gadget.i))
      
      If IsFont(\FontTexte)
        FreeFont(\FontTexte)
      EndIf
      
      ButtonFont.i = LoadFont(#PB_Any, PoliceTexte.s, TailleTexte.i, StyleTexte.i | #PB_Font_HighQuality)

      If IsFont(ButtonFont.i)
        \PoliceTexte = PoliceTexte.s
        \TailleTexte = TailleTexte.i
        \StyleTexte = StyleTexte.i | #PB_Font_HighQuality
        \FontTexte = ButtonFont.i
        
      Else
        ProcedureReturn 0
        
      EndIf
      
      If CreateButtonColor(Gadget.i, GadgetX(Gadget.i), GadgetY(Gadget.i), GadgetWidth(Gadget.i), GadgetHeight(Gadget.i), \Texte, \CouleurTexte, \CouleurBouton, \Interrupteur, \Curseur)
        ProcedureReturn 1
      Else
        ProcedureReturn 0
      EndIf
      
    EndWith
    
  Else
    ProcedureReturn 0
    
  EndIf
  
EndProcedure

; Change les couleurs gradient du texte du bouton.
Procedure.b SetButtonColorGradientTextColor(Gadget.i, Mode.i, Couleur1.i, Couleur2.i, Couleur3.i, Couleur4.i, Couleur5.i)
  
  If IsGadget(Gadget.i)
    
    With ArrayButtonColor(Str(Gadget.i))
      
      If Mode.i < 1
        Mode.i = 1
      ElseIf Mode.i > 2
        Mode.i = 2
      EndIf
      
      \GradientModeTexte = Mode.i
      
      \CouleurGradientTexte1 = Couleur1.i
      \CouleurGradientTexte2 = Couleur2.i
      \CouleurGradientTexte3 = Couleur3.i
      \CouleurGradientTexte4 = Couleur4.i
      \CouleurGradientTexte5 = Couleur5.i
      
      If CreateButtonColor(Gadget.i, GadgetX(Gadget.i), GadgetY(Gadget.i), GadgetWidth(Gadget.i), GadgetHeight(Gadget.i), \Texte, \CouleurTexte, \CouleurBouton, \Interrupteur, \Curseur)
        ProcedureReturn 1
      Else
        ProcedureReturn 0
      EndIf
      
    EndWith
    
  Else
    ProcedureReturn 0
    
  EndIf
  
EndProcedure
  
; Change les couleurs gradient du fond du bouton.
Procedure.b SetButtonColorGradientBackColor(Gadget.i, Mode.i, Couleur1.i, Couleur2.i, Couleur3.i, Couleur4.i, Couleur5.i)
  
  If IsGadget(Gadget.i)
    
    With ArrayButtonColor(Str(Gadget.i))
      
      If Mode.i < 1
        Mode.i = 1
      ElseIf Mode.i > 2
        Mode.i = 2
      EndIf
      
      \GradientModeFond = Mode.i
      
      \CouleurGradientFond1 = Couleur1.i
      \CouleurGradientFond2 = Couleur2.i
      \CouleurGradientFond3 = Couleur3.i
      \CouleurGradientFond4 = Couleur4.i
      \CouleurGradientFond5 = Couleur5.i
      
      If CreateButtonColor(Gadget.i, GadgetX(Gadget.i), GadgetY(Gadget.i), GadgetWidth(Gadget.i), GadgetHeight(Gadget.i), \Texte, \CouleurTexte, \CouleurBouton, \Interrupteur, \Curseur)
        ProcedureReturn 1
      Else
        ProcedureReturn 0
      EndIf
      
    EndWith
    
  Else
    ProcedureReturn 0
    
  EndIf
  
EndProcedure

; Change un attribut du bouton.
Procedure.b SetButtonColorAttribute(Gadget.i, Attribut.i, Valeur.i)
  
  If IsGadget(Gadget.i)
    
    With ArrayButtonColor(Str(Gadget.i))
      
      Select Attribut.i
          
        Case #BC_TextColor
          \CouleurTexte = Valeur.i
          
        Case #BC_TextPosition
          \PositionTexteBouton = Valeur.i
          
        Case #BC_TextOffSetX
          \OffsetXTexteBouton = Valeur.i
          
        Case #BC_TextOffSetY
          \OffsetYTexteBouton = Valeur.i
          
        Case #BC_BackColor
          \CouleurBouton = Valeur.i
          
        Case #BC_AngleText
          \AngleTexte = Valeur.i
          
        Case #BC_Cursor ; #BC_Cursor_APPSTARTING, #BC_Cursor_ARROW, #BC_Cursor_CROSS, #BC_Cursor_HAND, #BC_Cursor_HELP, #BC_Cursor_IBEAM, #BC_Cursor_NO, #BC_Cursor_SIZEALL, #BC_Cursor_SIZENESW, #BC_Cursor_SIZEWE, #BC_Cursor_SIZENS, #BC_Cursor_SIZENWSE, #BC_Cursor_UPARROW, #BC_Cursor_WAIT
          \Curseur = Valeur.i
          
        Case #BC_Image
          \TransparenceImageBouton = 255
          \ImageBouton = Valeur.i
          
        Case #BC_ImageTransparence
          \TransparenceImageBouton = Valeur.i
          
        Case #BC_ImagePosition
          \PositionImageBouton = Valeur.i
          
        Case #BC_ImageOffSetX
          \OffsetXImageBouton = Valeur.i
          
        Case #BC_ImageOffSetY
          \OffsetYImageBouton = Valeur.i
          
        Case #BC_Toogle
          
          If Valeur.i <> 0 And Valeur.i <> 1
            Valeur.i = #False
          EndIf
          
          \Interrupteur = Valeur.i
          
        Case #BC_Style ; #BC_Style_Default, #BC_Style_Flat, #BC_Style_NoBorder, #BC_Style_3D
          \StyleBouton = Valeur.i
          
      EndSelect
      
      If CreateButtonColor(Gadget.i, GadgetX(Gadget.i), GadgetY(Gadget.i), GadgetWidth(Gadget.i), GadgetHeight(Gadget.i), \Texte, \CouleurTexte, \CouleurBouton, \Interrupteur, \Curseur)
        ProcedureReturn 1
      Else
        ProcedureReturn 0
      EndIf
      
    EndWith
    
  Else
    ProcedureReturn 0
    
  EndIf
  
EndProcedure

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; Retourne le numéro d'identification de l'image (ImageID) qui compose le bouton.
Procedure.i GetButtonColorImageID(Gadget.i)
  If IsGadget(Gadget.i)
    ProcedureReturn ArrayButtonColor(Str(Gadget.i))\BoutonImageID
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

; Retourne le texte du bouton.
Procedure.s GetButtonColorText(Gadget.i)
  If IsGadget(Gadget.i)
    ProcedureReturn ArrayButtonColor(Str(Gadget.i))\Texte
  Else
    ProcedureReturn ""
  EndIf
EndProcedure

; Retourne le nom de la police du bouton.
Procedure.s GetButtonColorFontName(Gadget.i)
  If IsGadget(Gadget.i)
    ProcedureReturn ArrayButtonColor(Str(Gadget.i))\PoliceTexte
  Else
    ProcedureReturn ""
  EndIf
EndProcedure

; Retourne la taille de la police du bouton.
Procedure.i GetButtonColorFontSize(Gadget.i)
  If IsGadget(Gadget.i)
    ProcedureReturn ArrayButtonColor(Str(Gadget.i))\TailleTexte
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

; Retourne le style de la police du bouton.
Procedure.i GetButtonColorFontStyle(Gadget.i)
  If IsGadget(Gadget.i)
    ProcedureReturn ArrayButtonColor(Str(Gadget.i))\StyleTexte
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

; Retourne un attribut du bouton.
Procedure.i GetButtonColorAttribute(Gadget.i, Attribut.i)
  
  If IsGadget(Gadget.i)
    
    With ArrayButtonColor(Str(Gadget.i))
      
      Select Attribut.i
          
        Case #BC_TextColor
          ProcedureReturn \CouleurTexte
          
        Case #BC_GradiantTextMode
          ProcedureReturn \GradientModeTexte
          
        Case #BC_GradiantTextColor1
          ProcedureReturn \CouleurGradientTexte1
          
        Case #BC_GradiantTextColor2
          ProcedureReturn \CouleurGradientTexte2
          
        Case #BC_GradiantTextColor3
          ProcedureReturn \CouleurGradientTexte3
          
        Case #BC_GradiantTextColor4
          ProcedureReturn \CouleurGradientTexte4
          
        Case #BC_GradiantTextColor5
          ProcedureReturn \CouleurGradientTexte5
          
        Case #BC_TextX
          ProcedureReturn \XTexte
          
        Case #BC_TextY
          ProcedureReturn \YTexte
          
        Case #BC_TextPosition
          ProcedureReturn \PositionTexteBouton
          
        Case #BC_TextOffSetX
          ProcedureReturn \OffsetXTexteBouton
          
        Case #BC_TextOffSetY
          ProcedureReturn \OffsetYTexteBouton
          
        Case #BC_BackColor
          ProcedureReturn \CouleurBouton
          
        Case #BC_GradiantFondMode
          ProcedureReturn \GradientModeFond
          
        Case #BC_GradiantBackColor1
          ProcedureReturn \CouleurGradientFond1
          
        Case #BC_GradiantBackColor2
          ProcedureReturn \CouleurGradientFond2
          
        Case #BC_GradiantBackColor3
          ProcedureReturn \CouleurGradientFond3
          
        Case #BC_GradiantBackColor4
          ProcedureReturn \CouleurGradientFond4
          
        Case #BC_GradiantBackColor5
          ProcedureReturn \CouleurGradientFond5
          
        Case #BC_AngleText
          ProcedureReturn \AngleTexte
          
        Case #BC_Cursor
          ProcedureReturn \Curseur
          
        Case #BC_Image
          ProcedureReturn \ImageBouton
          
        Case #BC_ImageTransparence
          ProcedureReturn \TransparenceImageBouton
          
        Case #BC_ImageX
          ProcedureReturn \XImageBouton
          
        Case #BC_ImageY
          ProcedureReturn \YImageBouton
          
        Case #BC_ImageOffSetX
          ProcedureReturn \OffsetXImageBouton
          
        Case #BC_ImageOffSetY
          ProcedureReturn \OffsetYTexteBouton
          
        Case #BC_ImagePosition
          ProcedureReturn \PositionImageBouton
          
        Case #BC_Toogle
          ProcedureReturn \Interrupteur
          
        Case #BC_Style
          ProcedureReturn \StyleBouton
          
        Default
          ProcedureReturn 0
          
      EndSelect
      
    EndWith
    
  Else
    ProcedureReturn 0
    
  EndIf
  
EndProcedure

;}

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 720
; FirstLine = 10
; Folding = QAA+
; EnableXP
; EnableUser
; EnableOnError
; EnableCompileCount = 1632
; EnableBuildCount = 0
; EnableExeConstant